import processing.core.*; 
import processing.xml.*; 

import ddf.minim.*; 

import java.applet.*; 
import java.awt.*; 
import java.awt.image.*; 
import java.awt.event.*; 
import java.io.*; 
import java.net.*; 
import java.text.*; 
import java.util.*; 
import java.util.zip.*; 
import java.util.regex.*; 

public class peli extends PApplet {



Minim minim;
AudioPlayer music;
AudioSample hit;
AudioSample laser;

PImage feedback;

// processing game
int ctext = 0;
int lives = 0;
int oneuplevel = 0;
int extralife = 0;
int prevenemy = 0;
int combo = 0;
int debug = 0;
int keyUp = 0;
int keyDown = 0;
int keyLeft = 0;
int keyRight = 0;
int keyFire = 0;
int player_base = 270;
int gameover = 0;
int score = 0;
float jump_height = 260;
float player_x=0;
float player_y=player_base;
float player_speed=1.9f;
float player_animspeed = 0.13f;
float player_jump=0;
int player_animframe = 0;
int player_walking = 0;
int player_jumping = 0; 
float player_anim = 0; 
int texttime = 0;

int soundframes=50;

PImage player_w1;
PImage player_w2;
PImage player_w3;
PImage player_w4;
PImage player_w5;
PImage player_w6;
PImage player_stand;

int enemy_count_current = 0;
int enemy_count = 50;
int enemy_size = 64;
Enemy[] enemies;

int bullet_count = 18;
int bullet_size = 15;
float bullet_speed = 5;

Bullet[] bullets;

PFont font;

String[] texts;

public void setup() {
  size(640,320,P2D);
  frameRate(30);
  player_w1 = loadImage("p1.png");
  player_w2 = loadImage("p2.png");
  player_w3 = loadImage("p3.png");
  player_w4 = loadImage("p4.png");
  player_w5 = loadImage("p5.png");
  player_w6 = loadImage("p6.png");
  player_stand = loadImage("p_stand.png");
  
  minim = new Minim(this);
  music = minim.loadFile("loop.mp3", 8124*2);
  laser = minim.loadSample("laser.wav", 1024*2);
  hit = minim.loadSample("hit.wav", 1024);
  
  texts = new String[30];
  
  texts[0] = "trilobit / escapism";
  texts[1] = "Why is this here?";
  texts[2] = "...forgot myself there";
  texts[3] = "hat's off? now?";
  texts[4] = "what is this melancholy";
  texts[5] = "supportive? me?";
  texts[6] = "do it, just do it";
  texts[7] = "quite right you are";
  texts[8] = "and when is that?";
  texts[9] = "which way did it go?";
  texts[10] = "don't make me laugh!";
  texts[11] = "i have no idea";
  texts[12] = "a lung disease";
  texts[13] = "destroy the supports";
  texts[14] = "why is that? really!";
  texts[15] = "which way again?";
  texts[16] = "structs? metal structs?";
  texts[17] = "gas pipe is not me";
  texts[18] = "a red cardigan.";
  texts[19] = "towels were brought";
  texts[20] = "sad but sightful.";
  texts[21] = "endless voyage?";
  texts[22] = "who is at the door?";
  texts[23] = "it's breakfast time!";
  texts[24] = "teleportation is a dream";
  texts[25] = "buy my book! buy my book!";
  texts[26] = "i'm so happy i might cry";
  texts[27] = "no!";
  texts[28] = "be a little supportive";
  texts[29] = "it's a pipe dream";

ctext = 0;
lives = 0;
oneuplevel = 0;
extralife = 0;
keyUp = 0;
keyDown = 0;
keyLeft = 0;
keyRight = 0;
keyFire = 0;
player_base = 270;
gameover = 0;
score = 0;
jump_height = 260;
player_x=0;
player_y=player_base;
player_speed=2.9f;
player_animspeed = 0.6f;
player_jump=0;
player_animframe = 0;
player_walking = 0;
player_jumping = 0; 
player_anim = 0; 
texttime = 0;

enemy_count_current = 0;
enemy_count = 50;
enemy_size = 64;

bullet_count = 18;
bullet_size = 15;
bullet_speed = 5;

prevenemy = 0;
combo = 0;

  enemies = new Enemy[enemy_count];
  for (int j = 0;j<enemy_count;j++) {
    enemies[j] = new Enemy(); 
  }
  spawnEnemies(5);
  
  bullets = new Bullet[bullet_count];
  for (int i = 0;i<bullet_count;i++) {
    bullets[i] = new Bullet(0.0f,0.0f,false);
  }
  
  font = loadFont("font.vlw");
  textFont(font, 32);

  feedback = get();

  loop();
  music.loop();


}

public void keyReleased() {
  if (key == 'w' || keyCode == UP) keyUp = 2;
  if (key == 's' || keyCode == DOWN) keyDown = 2;
  if (key == 'a' || keyCode == LEFT) keyLeft = 2;
  if (key == 'd' || keyCode == RIGHT) keyRight = 2;
  if (key == ' ') keyFire = 2;
  if (key == 'r' && gameover > 0) { 
    setup(); 
  }
}

public void keyPressed() {
  if (key == 'w' || keyCode == UP) keyUp = 1;
  if (key == 's' || keyCode == DOWN) keyDown = 1;
  if (key == 'a' || keyCode == LEFT) keyLeft = 1;
  if (key == 'd' || keyCode == RIGHT) keyRight = 1;
  if (key == ' ') keyFire = 1;
}

public void drawBG() {
  background(123,138,153);
}

public void spawnEnemies(int count) {
  int i;
  if (enemy_count_current+count < enemy_count) {
    for (i=0;i<count;i++) {
      enemies[enemy_count_current] = new Enemy(enemy_count_current+1);
      enemy_count_current++;
    }
  }
  
  int al = 0;

  for (i=0;i<enemy_count_current;i++) {
    if (enemies[i].alive == true) al = 1;
  }
  if (al == 0) gameover = 2;
}

public void drawLevel() {
  int i;
  textAlign(CENTER);

  for (i=0;i<enemy_count_current;i++) {
    enemies[i].update();
    pushMatrix();
    if (enemies[i].falling) { rotate(enemies[i].r);}
    if (!enemies[i].falling & (i%2==0)) stroke(192,0,0);
    else if (!enemies[i].falling & (!(i%2==0)))stroke(0,192,0);
    else if (enemies[i].falling & (i%2==0)) stroke(255,0,0,255-constrain(enemies[i].y, 0, 255));
    else if (enemies[i].falling & (!(i%2==0))) stroke(0,255,0,255-constrain(enemies[i].y, 0, 255));
    
    int ecolor = 35+enemies[i].type*6;
    if (ecolor >= 255) ecolor = 255;
    if (enemies[i].alive & (i % 2==0)) fill(ecolor,0,0,255);
    else if (enemies[i].alive & (!(i%2==0))) fill(0,ecolor,0,255);
    else noFill();
    if (enemies[i].y < height) rect((int)enemies[i].x, (int)enemies[i].y, enemy_size, enemy_size);
        if (enemies[i].alive & (i % 2==0)) fill(192,0,0,255);
    else if (enemies[i].alive & (!(i%2==0))) fill(0,192,0,255);
    if (enemies[i].alive) text((enemies[i].type-1)/2, enemies[i].x+enemy_size/2, enemies[i].y+enemy_size/2+12);
    popMatrix();

    if (player_x+30 >= enemies[i].x && player_x <= enemies[i].x+enemy_size && player_y+45 >= enemies[i].y && player_y <= enemies[i].y+enemy_size && enemies[i].alive) {
      lives--;
      enemies[i].alive = false;
      enemies[i].falling = true;
      fill(255,0,0,180);
      rect(0,0,width,height);
    }
    
    if (lives < 0) {
      gameover = 1;
    }

    for (int j=0;j<bullet_count;j++) {
      if (bullets[j].alive == true) {
        if (bullets[j].x+bullet_size >= enemies[i].x && bullets[j].x <= enemies[i].x+enemy_size && bullets[j].y >= enemies[i].y && bullets[j].y <= enemies[i].y+enemy_size && enemies[i].alive == true) { 
          hit.trigger();
          enemies[i].type-=2;
          if (prevenemy == i) combo++;
          else combo = 0;
          prevenemy = i;
          
          if (debug == 1) enemies[i].type = 0;
          bullets[j].alive = false;
          score+=((2+enemies[i].type)*112)*(combo+1); 
          if (score >= 100000 && oneuplevel == 0) { lives+=1; oneuplevel++; extralife = 50; }
          if (score >= 250000 && oneuplevel == 1) { lives+=1; oneuplevel++; extralife = 50; }
          if (score >= 350000 && oneuplevel == 2) { lives+=1; oneuplevel++; extralife = 50; }
          if (score >= 500000 && oneuplevel == 3) { lives+=1; oneuplevel++; extralife = 50; }
          if (score >= 800000 && oneuplevel == 4) { lives+=1; oneuplevel++; extralife = 50; }
          if (score >= 1000000 && oneuplevel == 5) { lives+=1; oneuplevel++; extralife = 50; }
          if (score >= 1500000 && oneuplevel == 6) { lives+=1; oneuplevel++; extralife = 50; }
          if (score >= 2200000 && oneuplevel == 7) { lives+=1; oneuplevel++; extralife = 50; }
          if (score >= 2800000 && oneuplevel == 8) { lives+=1; oneuplevel++; extralife = 50; }
          if (score >= 3000000 && oneuplevel == 9) { lives+=1; oneuplevel++; extralife = 50; } 
          
          if (enemies[i].type <= 0) {
            enemies[i].alive = false;
            enemies[i].falling = true;
            spawnEnemies((int)(random(1,3)));
          }
        }
      }
    }
  }
  
  noStroke();
  fill(64);
  rect(0,0,width,6);
  fill(86);
  rect(0,height-8,width,height);

  
}

public void drawPlayer() {
  
  if (keyUp == 1 && player_jumping == 0) {
    player_jumping = 1;
  }
  
  if (keyDown == 1 && player_jumping == 1) {
    player_jumping = 2;
  }
  
  if (keyLeft == 1) {
    player_x -= player_speed;
    player_anim+=player_animspeed;
    if(player_anim >= 7) player_anim = 1;
    if (player_walking == 0) { player_walking = 1; player_anim = 6;}
    
  }
  else if (keyRight == 1) {
    player_x += player_speed;
    player_anim+=player_animspeed;
    if(player_anim >= 7) player_anim = 1;
    if (player_walking == 0) { player_walking = 1; player_anim = 6;}
  }
  
  if (keyLeft == 2) {
    player_anim = 0;
    keyLeft = 0;

  }
  else if (keyRight == 2) {
    player_anim = 0;
    keyRight = 0;
  }
  
  if (player_jumping == 1) {
    if (player_jump < jump_height) player_jump+=player_speed*2;
    else {
      player_jumping = 2;
    }
  }
  
  if (player_jumping == 2) {
    if (player_jump > 0) player_jump-=player_speed*2;
    else {
      player_jumping = 0;
    }
  }
  
  if (player_x < 0) player_x = 0;
  if (player_x > 640-35) player_x = 640-35;
  
  player_y=player_base-player_jump;

  player_animframe = (int)player_anim;
  if (player_walking == 0) player_animframe = 0;
  if (player_jumping != 0) player_animframe = 1;

  imageMode(CORNERS);
  if (player_animframe == 0) image(player_stand, player_x, player_y);
  else if (player_animframe == 1) image(player_w1, player_x, player_y);
  else if (player_animframe == 2) image(player_w2, player_x, player_y);
  else if (player_animframe == 3) image(player_w3, player_x, player_y);
  else if (player_animframe == 4) image(player_w4, player_x, player_y);
  else if (player_animframe == 5) image(player_w5, player_x, player_y);
  else if (player_animframe == 6) image(player_w6, player_x, player_y);
}

public void newBullet(float x, float y) {
  int i = 0;
  int done = 0;
  for (i = 0;i < bullet_count; i++) {
    if (bullets[i].alive == false) {
      bullets[i].x = x;
      bullets[i].starty = y;
      bullets[i].speed = bullet_speed;
      bullets[i].alive = true;
          laser.trigger();
      done = 1;
    }
    if (done == 1) break;
  }
}

public void drawBullets() {
  if (keyFire == 2) {
    keyFire = 0;
    newBullet(player_x+14, player_y+8);


  }
  for (int i = 0; i < bullet_count; i++) {
    bullets[i].update();
    if (bullets[i].alive) {
      noFill();
      stroke(0,255,50);
      line(bullets[i].x, bullets[i].y, bullets[i].x+2,bullets[i].y);
      stroke(0,255,100);
      line(bullets[i].x+2, bullets[i].y, bullets[i].x+4,bullets[i].y);
      stroke(0,255,150);
      line(bullets[i].x+4, bullets[i].y, bullets[i].x+6,bullets[i].y);
      stroke(0,255,200);
      line(bullets[i].x+6, bullets[i].y, bullets[i].x+8,bullets[i].y);
    }
  }
}

public void draw() {
  //drawBG();
  pushMatrix();
  scale(0.999f);
  rotate(sin(millis()*0.001f)*0.01f);
  tint(225,225,225,254);
  image(feedback,0,0);
  popMatrix();
  tint(255,255,255,255);

  drawLevel();
  if (gameover == 0) drawTexts();
  if (gameover == 0) drawPlayer();
  if (gameover == 0) drawBullets();
  if (gameover == 1) {
    gameover();
  }
  if (gameover == 2) {
    win();
  }

  if (gameover == 0) drawScore();
  feedback = get();

  drawFrame();
  
}

public void drawScore() {
  textAlign(LEFT);
  fill(192,192,192);
  text("Score: " + score,2,34);  
  fill(240,240,240);
  text("Score: " + score,3,35);  
  fill(0,190,0);
  if (combo > 0) text((combo+1) + "X COMBO!", 2,34+32);
  fill(0,240,0);
  if (combo > 0) text((combo+1) + "X COMBO!", 3,34+33);

  int ecounter = enemy_count_current;

  if (enemy_count_current == 49) ecounter = 50;
  
  

  fill(0,190,190);
  text(ecounter + " of " + enemy_count, width-85,34);
  fill(0,240,240);
  text(ecounter + " of " + enemy_count, width-85,35);

    textAlign(CENTER);
  
  fill(190,0,190);
  text("Reincarnations: " + lives, width/2,34);
  fill(240,0,240);
  text("Reincarnations: " + lives, width/2,35);
  
    if (extralife > 0) {
    extralife--;
    fill(255,0,255);
    text("Another cycle added!", width/2, 35+32);
  }

  
  
}

public void drawFrame() {
  noFill();
  stroke(0);
  rect(0,0,width-1,height-1);
}

public void drawTexts() {
  float a = 128+cos(millis()*0.0001f)*355;
  float b = 128+sin(millis()*0.0012f)*300;
  float c = 128+cos(millis()*0.00015f)*255;
  
  fill(a,b,c,255);
  stroke(0);
  textAlign(CENTER);
  text(texts[ctext], width/2,height/2);
  texttime++;
  if (texttime > 500) {
    texttime = 0;
    ctext = (int)random(1,30);
  }
}

public void gameover() {
  fill(255,0,0,210);
  stroke(0);
  rect(0,0,width-1,height-1);
  textAlign(CENTER);
  fill(0,0,0,255);
  stroke(0);
  text("G A M E   O V E R",width/2,(height/2)-48);
  text("there is no exit",width/2,(height/2)-14);
  text("SCORE: " + score,width/2,(height/2)+32);
  text("[R] restarts", width/2,height-68);
  fill(0,0,0);
  textAlign(LEFT);
  text("code  visy", 2, height+4-16*2);
  text("music and sfx  ilmarque", 2, height+4-16*1);
  text("graphics  indie game resources", 2, height+4);

  music.close();
  laser.close();
  hit.close();
  minim.stop();
  
  noLoop();
}

public void win() {
  fill(0,255,0,210);
  stroke(0);
  rect(0,0,width-1,height-1);
  textAlign(CENTER);
  fill(0,0,0,255);
  stroke(0);
  text("T H E   E N D",width/2,(height/2)-48);
  text("the worthy shall be driven to the exit",width/2,(height/2)-14);
  text("SCORE: " + score,width/2,(height/2)+32);
  text("[R] restarts", width/2,height-68);
  fill(0,0,0);
  textAlign(LEFT);
  text("code  visy", 2, height+4-16*2);
  text("music and sfx  ilmarque", 2, height+4-16*1);
  text("graphics  indie game resources", 2, height+4);
  music.close();
  laser.close();
  hit.close();
  minim.stop();
  noLoop();
}

class Bullet {
  float x,y;
  float starty;
  float speed;
  boolean alive;
  
  Bullet(float ex, float ey, boolean ealive) {
    x = ex;
    starty = ey;
    alive = ealive;
  }
  
  public void update() {
    x+=speed;
    y=starty+sin(x*0.1f)*5;
    if (x > width) alive = false;
  }
}

class Enemy {
  float x,y;
  float starty;
  float speed;
  int type;
  boolean alive;
  boolean falling;
  float r;
  
  Enemy(int etype) {
    x = width+20;
    starty = random(26,height-enemy_size-enemy_size);
    speed = etype*0.03f;
    type = etype;
    alive = true;
    falling = false;
    r = 0;
  }  
  
  Enemy() {
    alive = false;
    falling  = false;
    x = width;
    y = height;
    speed = 0;
    type = 0;
    r = 0;
  }
  
  public void update() {
    speed = type*0.3f;
    if (falling) speed = 1;
    x-=speed;
    if (falling == false) y=starty+cos(x*0.006f)*(height-enemy_size-enemy_size)/8;
    if (y < 6) y = 6;
    if (y+enemy_size > height-8 && falling == false) y = height-8-enemy_size;
    if (x <= -enemy_size && alive == true) x = width+20;
    if (y < height && falling == true) { y+=0.9f; r+=0.005f;}
 
  }
}

public void stop() {
  if (gameover == 0) music.close();
  minim.stop();
  super.stop();
}

  static public void main(String args[]) {
    PApplet.main(new String[] { "--bgcolor=#FFFFFF", "peli" });
  }
}
